/*
  File autogenerated by gengetopt version 2.23
  generated with the following command:
  /usr/bin/gengetopt -i RNApvmin.ggo --file-name=RNApvmin_cmdl --include-getopt --default-optional --unamed-opts --func-name=RNApvmin_cmdline_parser --arg-struct-name=RNApvmin_args_info

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FIX_UNUSED
#define FIX_UNUSED(X) (void) (X) /* avoid warnings for unused params */
#endif


#include "RNApvmin_cmdl.h"

const char *RNApvmin_args_info_purpose = "Calculate a perturbation vector that minimizes discripancies between predicted\nand observed pairing probabilities";

const char *RNApvmin_args_info_usage = "Usage: RNApvmin [options] <file.shape>";

const char *RNApvmin_args_info_versiontext = "";

const char *RNApvmin_args_info_description = "The program reads a RNA sequence from stdin and uses an iterative minimization\nprocess to calculate a perturbation vector that minimizes the discripancies\nbetween predicted pairing probabilites and observed pairing probabilities\n(deduced from given shape reactivities). Experimental data is read from a given\nSHAPE file and normalized to pairing probabilities. The experimental data has\nto be provided in a multiline plain text file where each line has the format\n'[position] [nucleotide] [absolute shape reactivity]' (e.g. '3 A 0.7'). The\nobjective function used for the minimization may be weighted by choosing\nappropriate values for sigma and tau.\n\nThe minimization progress will be written to stderr. Once the minimization has\nterminated, the obtained perturbation vector is written to stdout.";

const char *RNApvmin_args_info_detailed_help[] = {
  "  -h, --help                    Print help and exit",
  "      --detailed-help           Print help, including all details and hidden\n                                  options, and exit",
  "      --full-help               Print help, including hidden options, and exit",
  "  -V, --version                 Print version and exit",
  "\nGeneral Options:",
  "  Below are command line options which alter the general behavior of this\n  program\n\n",
  "  -j, --numThreads=INT          Set the number of threads used for\n                                  calculations.",
  "      --shapeConversion=STRING  Specify the method used to convert SHAPE\n                                  reactivities to pairing probabilities.\n                                  (default=`O')",
  "  The following methods can be used to convert SHAPE reactivities into the\n  probability for a certain nucleotide to be unpaired.\n\n  'M': Use linear mapping according to Zarringhalam et al. 2012\n\n  'C': Use a cutoff-approach to divide into paired and unpaired nucleotides\n  (e.g. \"C0.25\")\n\n  'S': Skip the normalizing step since the input data already represents\n  probabilities for being unpaired rather than raw reactivity values\n\n  'L': Use a linear model to convert the reactivity into a probability for\n  being unpaired (e.g. \"Ls0.68i0.2\" to use a slope of 0.68 and an intercept\n  of 0.2)\n\n  'O': Use a linear model to convert the log of the reactivity into a\n  probability for being unpaired (e.g. \"Os1.6i-2.29\" to use a slope of 1.6\n  and an intercept of -2.29)\n",
  "      --tauSigmaRatio=DOUBLE    Ratio of the weighting factors tau and sigma.\n                                  (default=`1.0')",
  "  A high ratio will lead to a solution as close as possible to the experimental\n  data, while a low ratio will lead to results close to the thermodynamic\n  prediction without guiding pseudo energies.\n",
  "      --objectiveFunction=INT   The energies of the perturbation vector and the\n                                  discripancies between predicted and observed\n                                  pairing probabilities contribute to the\n                                  objective function. This parameter defines,\n                                  which function is used to process the\n                                  contributions before summing them up.\n                                  0 square\n                                  1 absolute.  (default=`0')",
  "      --sampleSize=INT          The iterative minimization process requires to\n                                  evaluate the gradient of the objective\n                                  function.  (default=`1000')",
  "  A sample size of 0 leads to an analytical evaluation which scales as O(N^4).\n  Choosing a sample size >0 estimates the gradient by sampling the given number\n  of sequences from the ensemble, which is much faster.\n",
  "  -N, --nonRedundant            Enable non-redundant sampling strategy.\n                                  (default=off)",
  "      --intermediatePath=STRING Write an output file for each iteration of the\n                                  minimization process.",
  "  Each file contains the used perturbation vector and the score of the\n  objective function. The number of the iteration will be appended to the given\n  path.\n",
  "      --initialVector=DOUBLE    Specify the vector of initial pertubations.\n                                  (default=`0')",
  "  Defines the initial perturbation vector which will be used as starting vector\n  for the minimization process. The value 0 results in a null vector. Every\n  other value x will be used to populate the initial vector with random numbers\n  from the interval [-x,x].\n",
  "      --minimizer=ENUM          Set the minimizing algorithm used for finding\n                                  an appropriate perturbation vector.\n                                  (possible values=\"conjugate_fr\",\n                                  \"conjugate_pr\", \"vector_bfgs\",\n                                  \"vector_bfgs2\", \"steepest_descent\",\n                                  \"default\" default=`default')",
  "  The default option uses a custom implementation of the gradient descent\n  algorithms while all other options represent various algorithms implemented\n  in the GNU Scientific Library. When the GNU Scientific Library can not be\n  found, only the default minimizer is available.\n",
  "      --initialStepSize=DOUBLE  The initial stepsize for the minimizer methods.\n                                  (default=`0.01')",
  "      --minStepSize=DOUBLE      The minimal stepsize for the minizimer methods.\n                                  (default=`1e-15')",
  "      --minImprovement=DOUBLE   The minimal improvement in the default\n                                  minizimer method that has to be surpassed to\n                                  considered a new result a better one.\n                                  (default=`1e-3')",
  "      --minimizerTolerance=DOUBLE\n                                The tolerance to be used in the GSL minimizer\n                                  methods.  (default=`1e-3')",
  "\nModel Details:",
  "  -S, --pfScale=DOUBLE          Set scaling factor for Boltzmann factors to\n                                  prevent under/overflows.",
  "  In the calculation of the pf use scale*mfe as an estimate for the ensemble\n  free energy (used to avoid overflows). The default is 1.07, useful values are\n  1.0 to 1.2. Occasionally needed for long sequences.\n  You can also recompile the program to use double precision (see the README\n  file).\n",
  "  -T, --temp=DOUBLE             Rescale energy parameters to a temperature in\n                                  degrees centigrade.  (default=`37.0')",
  "  -4, --noTetra                 Do not include special tabulated stabilizing\n                                  energies for tri-, tetra- and hexaloop\n                                  hairpins.  (default=off)",
  "  Mostly for testing.\n",
  "  -d, --dangles=INT             Specify \"dangling end\" model for bases\n                                  adjacent to helices in free ends and\n                                  multi-loops.  (default=`2')",
  "  \n  With -d1 only unpaired bases can participate in at most one dangling end.\n  With -d2 this check is ignored, dangling energies will be added for the bases\n  adjacent to a helix on both sides in any case; this is the default for mfe\n  and partition function folding (-p).\n  The option -d0 ignores dangling ends altogether (mostly for debugging).\n  With -d3 mfe folding will allow coaxial stacking of adjacent helices in\n  multi-loops. At the moment the implementation will not allow coaxial stacking\n  of the two interior pairs in a loop of degree 3 and works only for mfe\n  folding.\n\n  Note that with -d1 and -d3 only the MFE computations will be using this\n  setting while partition function uses -d2 setting, i.e. dangling ends will be\n  treated differently.\n",
  "      --noLP                    Produce structures without lonely pairs\n                                  (helices of length 1).  (default=off)",
  "  For partition function folding this only disallows pairs that can only occur\n  isolated. Other pairs may still occasionally occur as helices of length 1.\n",
  "      --noGU                    Do not allow GU pairs.  (default=off)",
  "      --noClosingGU             Do not allow GU pairs at the end of helices.\n                                  (default=off)",
  "  -P, --paramFile=paramfile     Read energy parameters from paramfile, instead\n                                  of using the default parameter set.",
  "  Different sets of energy parameters for RNA and DNA should accompany your\n  distribution.\n  See the RNAlib documentation for details on the file format. When passing the\n  placeholder file name \"DNA\", DNA parameters are loaded without the need to\n  actually specify any input file.\n",
  "      --nsp=STRING              Allow other pairs in addition to the usual\n                                  AU,GC,and GU pairs.",
  "  Its argument is a comma separated list of additionally allowed pairs. If the\n  first character is a \"-\" then AB will imply that AB and BA are allowed\n  pairs.\n  e.g. RNAfold -nsp -GA  will allow GA and AG pairs. Nonstandard pairs are\n  given 0 stacking energy.\n",
  "  -e, --energyModel=INT         Set energy model.",
  "  Rarely used option to fold sequences from the artificial ABCD... alphabet,\n  where A pairs B, C-D etc.  Use the energy parameters for GC (-e 1) or AU (-e\n  2) pairs.\n",
  "      --maxBPspan=INT           Set the maximum base pair span.  (default=`-1')",
  "\nIf in doubt our program is right, nature is at fault.\nComments should be sent to rna@tbi.univie.ac.at.\n\n",
    0
};
static void
init_full_help_array(void)
{
  RNApvmin_args_info_full_help[0] = RNApvmin_args_info_detailed_help[0];
  RNApvmin_args_info_full_help[1] = RNApvmin_args_info_detailed_help[1];
  RNApvmin_args_info_full_help[2] = RNApvmin_args_info_detailed_help[2];
  RNApvmin_args_info_full_help[3] = RNApvmin_args_info_detailed_help[3];
  RNApvmin_args_info_full_help[4] = RNApvmin_args_info_detailed_help[4];
  RNApvmin_args_info_full_help[5] = RNApvmin_args_info_detailed_help[5];
  RNApvmin_args_info_full_help[6] = RNApvmin_args_info_detailed_help[6];
  RNApvmin_args_info_full_help[7] = RNApvmin_args_info_detailed_help[7];
  RNApvmin_args_info_full_help[8] = RNApvmin_args_info_detailed_help[9];
  RNApvmin_args_info_full_help[9] = RNApvmin_args_info_detailed_help[11];
  RNApvmin_args_info_full_help[10] = RNApvmin_args_info_detailed_help[12];
  RNApvmin_args_info_full_help[11] = RNApvmin_args_info_detailed_help[14];
  RNApvmin_args_info_full_help[12] = RNApvmin_args_info_detailed_help[15];
  RNApvmin_args_info_full_help[13] = RNApvmin_args_info_detailed_help[17];
  RNApvmin_args_info_full_help[14] = RNApvmin_args_info_detailed_help[19];
  RNApvmin_args_info_full_help[15] = RNApvmin_args_info_detailed_help[21];
  RNApvmin_args_info_full_help[16] = RNApvmin_args_info_detailed_help[22];
  RNApvmin_args_info_full_help[17] = RNApvmin_args_info_detailed_help[23];
  RNApvmin_args_info_full_help[18] = RNApvmin_args_info_detailed_help[24];
  RNApvmin_args_info_full_help[19] = RNApvmin_args_info_detailed_help[25];
  RNApvmin_args_info_full_help[20] = RNApvmin_args_info_detailed_help[26];
  RNApvmin_args_info_full_help[21] = RNApvmin_args_info_detailed_help[28];
  RNApvmin_args_info_full_help[22] = RNApvmin_args_info_detailed_help[29];
  RNApvmin_args_info_full_help[23] = RNApvmin_args_info_detailed_help[31];
  RNApvmin_args_info_full_help[24] = RNApvmin_args_info_detailed_help[33];
  RNApvmin_args_info_full_help[25] = RNApvmin_args_info_detailed_help[35];
  RNApvmin_args_info_full_help[26] = RNApvmin_args_info_detailed_help[36];
  RNApvmin_args_info_full_help[27] = RNApvmin_args_info_detailed_help[37];
  RNApvmin_args_info_full_help[28] = RNApvmin_args_info_detailed_help[39];
  RNApvmin_args_info_full_help[29] = RNApvmin_args_info_detailed_help[41];
  RNApvmin_args_info_full_help[30] = RNApvmin_args_info_detailed_help[43];
  RNApvmin_args_info_full_help[31] = RNApvmin_args_info_detailed_help[44];
  RNApvmin_args_info_full_help[32] = 0; 
  
}

const char *RNApvmin_args_info_full_help[33];

static void
init_help_array(void)
{
  RNApvmin_args_info_help[0] = RNApvmin_args_info_detailed_help[0];
  RNApvmin_args_info_help[1] = RNApvmin_args_info_detailed_help[1];
  RNApvmin_args_info_help[2] = RNApvmin_args_info_detailed_help[2];
  RNApvmin_args_info_help[3] = RNApvmin_args_info_detailed_help[3];
  RNApvmin_args_info_help[4] = RNApvmin_args_info_detailed_help[4];
  RNApvmin_args_info_help[5] = RNApvmin_args_info_detailed_help[5];
  RNApvmin_args_info_help[6] = RNApvmin_args_info_detailed_help[6];
  RNApvmin_args_info_help[7] = RNApvmin_args_info_detailed_help[7];
  RNApvmin_args_info_help[8] = RNApvmin_args_info_detailed_help[9];
  RNApvmin_args_info_help[9] = RNApvmin_args_info_detailed_help[11];
  RNApvmin_args_info_help[10] = RNApvmin_args_info_detailed_help[12];
  RNApvmin_args_info_help[11] = RNApvmin_args_info_detailed_help[14];
  RNApvmin_args_info_help[12] = RNApvmin_args_info_detailed_help[15];
  RNApvmin_args_info_help[13] = RNApvmin_args_info_detailed_help[17];
  RNApvmin_args_info_help[14] = RNApvmin_args_info_detailed_help[19];
  RNApvmin_args_info_help[15] = RNApvmin_args_info_detailed_help[25];
  RNApvmin_args_info_help[16] = RNApvmin_args_info_detailed_help[28];
  RNApvmin_args_info_help[17] = RNApvmin_args_info_detailed_help[29];
  RNApvmin_args_info_help[18] = RNApvmin_args_info_detailed_help[31];
  RNApvmin_args_info_help[19] = RNApvmin_args_info_detailed_help[33];
  RNApvmin_args_info_help[20] = RNApvmin_args_info_detailed_help[35];
  RNApvmin_args_info_help[21] = RNApvmin_args_info_detailed_help[36];
  RNApvmin_args_info_help[22] = RNApvmin_args_info_detailed_help[37];
  RNApvmin_args_info_help[23] = RNApvmin_args_info_detailed_help[43];
  RNApvmin_args_info_help[24] = RNApvmin_args_info_detailed_help[44];
  RNApvmin_args_info_help[25] = 0; 
  
}

const char *RNApvmin_args_info_help[26];

typedef enum {ARG_NO
  , ARG_FLAG
  , ARG_STRING
  , ARG_INT
  , ARG_DOUBLE
  , ARG_ENUM
} RNApvmin_cmdline_parser_arg_type;

static
void clear_given (struct RNApvmin_args_info *args_info);
static
void clear_args (struct RNApvmin_args_info *args_info);

static int
RNApvmin_cmdline_parser_internal (int argc, char **argv, struct RNApvmin_args_info *args_info,
                        struct RNApvmin_cmdline_parser_params *params, const char *additional_error);


const char *RNApvmin_cmdline_parser_minimizer_values[] = {"conjugate_fr", "conjugate_pr", "vector_bfgs", "vector_bfgs2", "steepest_descent", "default", 0}; /*< Possible values for minimizer. */

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct RNApvmin_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->detailed_help_given = 0 ;
  args_info->full_help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->numThreads_given = 0 ;
  args_info->shapeConversion_given = 0 ;
  args_info->tauSigmaRatio_given = 0 ;
  args_info->objectiveFunction_given = 0 ;
  args_info->sampleSize_given = 0 ;
  args_info->nonRedundant_given = 0 ;
  args_info->intermediatePath_given = 0 ;
  args_info->initialVector_given = 0 ;
  args_info->minimizer_given = 0 ;
  args_info->initialStepSize_given = 0 ;
  args_info->minStepSize_given = 0 ;
  args_info->minImprovement_given = 0 ;
  args_info->minimizerTolerance_given = 0 ;
  args_info->pfScale_given = 0 ;
  args_info->temp_given = 0 ;
  args_info->noTetra_given = 0 ;
  args_info->dangles_given = 0 ;
  args_info->noLP_given = 0 ;
  args_info->noGU_given = 0 ;
  args_info->noClosingGU_given = 0 ;
  args_info->paramFile_given = 0 ;
  args_info->nsp_given = 0 ;
  args_info->energyModel_given = 0 ;
  args_info->maxBPspan_given = 0 ;
}

static
void clear_args (struct RNApvmin_args_info *args_info)
{
  FIX_UNUSED (args_info);
  args_info->numThreads_orig = NULL;
  args_info->shapeConversion_arg = gengetopt_strdup ("O");
  args_info->shapeConversion_orig = NULL;
  args_info->tauSigmaRatio_arg = 1.0;
  args_info->tauSigmaRatio_orig = NULL;
  args_info->objectiveFunction_arg = 0;
  args_info->objectiveFunction_orig = NULL;
  args_info->sampleSize_arg = 1000;
  args_info->sampleSize_orig = NULL;
  args_info->nonRedundant_flag = 0;
  args_info->intermediatePath_arg = NULL;
  args_info->intermediatePath_orig = NULL;
  args_info->initialVector_arg = 0;
  args_info->initialVector_orig = NULL;
  args_info->minimizer_arg = minimizer_arg_default;
  args_info->minimizer_orig = NULL;
  args_info->initialStepSize_arg = 0.01;
  args_info->initialStepSize_orig = NULL;
  args_info->minStepSize_arg = 1e-15;
  args_info->minStepSize_orig = NULL;
  args_info->minImprovement_arg = 1e-3;
  args_info->minImprovement_orig = NULL;
  args_info->minimizerTolerance_arg = 1e-3;
  args_info->minimizerTolerance_orig = NULL;
  args_info->pfScale_orig = NULL;
  args_info->temp_arg = 37.0;
  args_info->temp_orig = NULL;
  args_info->noTetra_flag = 0;
  args_info->dangles_arg = 2;
  args_info->dangles_orig = NULL;
  args_info->noLP_flag = 0;
  args_info->noGU_flag = 0;
  args_info->noClosingGU_flag = 0;
  args_info->paramFile_arg = NULL;
  args_info->paramFile_orig = NULL;
  args_info->nsp_arg = NULL;
  args_info->nsp_orig = NULL;
  args_info->energyModel_orig = NULL;
  args_info->maxBPspan_arg = -1;
  args_info->maxBPspan_orig = NULL;
  
}

static
void init_args_info(struct RNApvmin_args_info *args_info)
{
  init_full_help_array(); 
  init_help_array(); 
  args_info->help_help = RNApvmin_args_info_detailed_help[0] ;
  args_info->detailed_help_help = RNApvmin_args_info_detailed_help[1] ;
  args_info->full_help_help = RNApvmin_args_info_detailed_help[2] ;
  args_info->version_help = RNApvmin_args_info_detailed_help[3] ;
  args_info->numThreads_help = RNApvmin_args_info_detailed_help[6] ;
  args_info->shapeConversion_help = RNApvmin_args_info_detailed_help[7] ;
  args_info->tauSigmaRatio_help = RNApvmin_args_info_detailed_help[9] ;
  args_info->objectiveFunction_help = RNApvmin_args_info_detailed_help[11] ;
  args_info->sampleSize_help = RNApvmin_args_info_detailed_help[12] ;
  args_info->nonRedundant_help = RNApvmin_args_info_detailed_help[14] ;
  args_info->intermediatePath_help = RNApvmin_args_info_detailed_help[15] ;
  args_info->initialVector_help = RNApvmin_args_info_detailed_help[17] ;
  args_info->minimizer_help = RNApvmin_args_info_detailed_help[19] ;
  args_info->initialStepSize_help = RNApvmin_args_info_detailed_help[21] ;
  args_info->minStepSize_help = RNApvmin_args_info_detailed_help[22] ;
  args_info->minImprovement_help = RNApvmin_args_info_detailed_help[23] ;
  args_info->minimizerTolerance_help = RNApvmin_args_info_detailed_help[24] ;
  args_info->pfScale_help = RNApvmin_args_info_detailed_help[26] ;
  args_info->temp_help = RNApvmin_args_info_detailed_help[28] ;
  args_info->noTetra_help = RNApvmin_args_info_detailed_help[29] ;
  args_info->dangles_help = RNApvmin_args_info_detailed_help[31] ;
  args_info->noLP_help = RNApvmin_args_info_detailed_help[33] ;
  args_info->noGU_help = RNApvmin_args_info_detailed_help[35] ;
  args_info->noClosingGU_help = RNApvmin_args_info_detailed_help[36] ;
  args_info->paramFile_help = RNApvmin_args_info_detailed_help[37] ;
  args_info->nsp_help = RNApvmin_args_info_detailed_help[39] ;
  args_info->energyModel_help = RNApvmin_args_info_detailed_help[41] ;
  args_info->maxBPspan_help = RNApvmin_args_info_detailed_help[43] ;
  
}

void
RNApvmin_cmdline_parser_print_version (void)
{
  printf ("%s %s\n",
     (strlen(RNAPVMIN_CMDLINE_PARSER_PACKAGE_NAME) ? RNAPVMIN_CMDLINE_PARSER_PACKAGE_NAME : RNAPVMIN_CMDLINE_PARSER_PACKAGE),
     RNAPVMIN_CMDLINE_PARSER_VERSION);

  if (strlen(RNApvmin_args_info_versiontext) > 0)
    printf("\n%s\n", RNApvmin_args_info_versiontext);
}

static void print_help_common(void)
{
	size_t len_purpose = strlen(RNApvmin_args_info_purpose);
	size_t len_usage = strlen(RNApvmin_args_info_usage);

	if (len_usage > 0) {
		printf("%s\n", RNApvmin_args_info_usage);
	}
	if (len_purpose > 0) {
		printf("%s\n", RNApvmin_args_info_purpose);
	}

	if (len_usage || len_purpose) {
		printf("\n");
	}

	if (strlen(RNApvmin_args_info_description) > 0) {
		printf("%s\n\n", RNApvmin_args_info_description);
	}
}

void
RNApvmin_cmdline_parser_print_help (void)
{
  int i = 0;
  print_help_common();
  while (RNApvmin_args_info_help[i])
    printf("%s\n", RNApvmin_args_info_help[i++]);
}

void
RNApvmin_cmdline_parser_print_full_help (void)
{
  int i = 0;
  print_help_common();
  while (RNApvmin_args_info_full_help[i])
    printf("%s\n", RNApvmin_args_info_full_help[i++]);
}

void
RNApvmin_cmdline_parser_print_detailed_help (void)
{
  int i = 0;
  print_help_common();
  while (RNApvmin_args_info_detailed_help[i])
    printf("%s\n", RNApvmin_args_info_detailed_help[i++]);
}

void
RNApvmin_cmdline_parser_init (struct RNApvmin_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);

  args_info->inputs = 0;
  args_info->inputs_num = 0;
}

void
RNApvmin_cmdline_parser_params_init(struct RNApvmin_cmdline_parser_params *params)
{
  if (params)
    { 
      params->override = 0;
      params->initialize = 1;
      params->check_required = 1;
      params->check_ambiguity = 0;
      params->print_errors = 1;
    }
}

struct RNApvmin_cmdline_parser_params *
RNApvmin_cmdline_parser_params_create(void)
{
  struct RNApvmin_cmdline_parser_params *params = 
    (struct RNApvmin_cmdline_parser_params *)malloc(sizeof(struct RNApvmin_cmdline_parser_params));
  RNApvmin_cmdline_parser_params_init(params);  
  return params;
}

static void
free_string_field (char **s)
{
  if (*s)
    {
      free (*s);
      *s = 0;
    }
}


static void
RNApvmin_cmdline_parser_release (struct RNApvmin_args_info *args_info)
{
  unsigned int i;
  free_string_field (&(args_info->numThreads_orig));
  free_string_field (&(args_info->shapeConversion_arg));
  free_string_field (&(args_info->shapeConversion_orig));
  free_string_field (&(args_info->tauSigmaRatio_orig));
  free_string_field (&(args_info->objectiveFunction_orig));
  free_string_field (&(args_info->sampleSize_orig));
  free_string_field (&(args_info->intermediatePath_arg));
  free_string_field (&(args_info->intermediatePath_orig));
  free_string_field (&(args_info->initialVector_orig));
  free_string_field (&(args_info->minimizer_orig));
  free_string_field (&(args_info->initialStepSize_orig));
  free_string_field (&(args_info->minStepSize_orig));
  free_string_field (&(args_info->minImprovement_orig));
  free_string_field (&(args_info->minimizerTolerance_orig));
  free_string_field (&(args_info->pfScale_orig));
  free_string_field (&(args_info->temp_orig));
  free_string_field (&(args_info->dangles_orig));
  free_string_field (&(args_info->paramFile_arg));
  free_string_field (&(args_info->paramFile_orig));
  free_string_field (&(args_info->nsp_arg));
  free_string_field (&(args_info->nsp_orig));
  free_string_field (&(args_info->energyModel_orig));
  free_string_field (&(args_info->maxBPspan_orig));
  
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);

  if (args_info->inputs_num)
    free (args_info->inputs);

  clear_given (args_info);
}

/**
 * @param val the value to check
 * @param values the possible values
 * @return the index of the matched value:
 * -1 if no value matched,
 * -2 if more than one value has matched
 */
static int
check_possible_values(const char *val, const char *values[])
{
  int i, found, last;
  size_t len;

  if (!val)   /* otherwise strlen() crashes below */
    return -1; /* -1 means no argument for the option */

  found = last = 0;

  for (i = 0, len = strlen(val); values[i]; ++i)
    {
      if (strncmp(val, values[i], len) == 0)
        {
          ++found;
          last = i;
          if (strlen(values[i]) == len)
            return i; /* exact macth no need to check more */
        }
    }

  if (found == 1) /* one match: OK */
    return last;

  return (found ? -2 : -1); /* return many values or none matched */
}


static void
write_into_file(FILE *outfile, const char *opt, const char *arg, const char *values[])
{
  int found = -1;
  if (arg) {
    if (values) {
      found = check_possible_values(arg, values);      
    }
    if (found >= 0)
      fprintf(outfile, "%s=\"%s\" # %s\n", opt, arg, values[found]);
    else
      fprintf(outfile, "%s=\"%s\"\n", opt, arg);
  } else {
    fprintf(outfile, "%s\n", opt);
  }
}


int
RNApvmin_cmdline_parser_dump(FILE *outfile, struct RNApvmin_args_info *args_info)
{
  int i = 0;

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot dump options to stream\n", RNAPVMIN_CMDLINE_PARSER_PACKAGE);
      return EXIT_FAILURE;
    }

  if (args_info->help_given)
    write_into_file(outfile, "help", 0, 0 );
  if (args_info->detailed_help_given)
    write_into_file(outfile, "detailed-help", 0, 0 );
  if (args_info->full_help_given)
    write_into_file(outfile, "full-help", 0, 0 );
  if (args_info->version_given)
    write_into_file(outfile, "version", 0, 0 );
  if (args_info->numThreads_given)
    write_into_file(outfile, "numThreads", args_info->numThreads_orig, 0);
  if (args_info->shapeConversion_given)
    write_into_file(outfile, "shapeConversion", args_info->shapeConversion_orig, 0);
  if (args_info->tauSigmaRatio_given)
    write_into_file(outfile, "tauSigmaRatio", args_info->tauSigmaRatio_orig, 0);
  if (args_info->objectiveFunction_given)
    write_into_file(outfile, "objectiveFunction", args_info->objectiveFunction_orig, 0);
  if (args_info->sampleSize_given)
    write_into_file(outfile, "sampleSize", args_info->sampleSize_orig, 0);
  if (args_info->nonRedundant_given)
    write_into_file(outfile, "nonRedundant", 0, 0 );
  if (args_info->intermediatePath_given)
    write_into_file(outfile, "intermediatePath", args_info->intermediatePath_orig, 0);
  if (args_info->initialVector_given)
    write_into_file(outfile, "initialVector", args_info->initialVector_orig, 0);
  if (args_info->minimizer_given)
    write_into_file(outfile, "minimizer", args_info->minimizer_orig, RNApvmin_cmdline_parser_minimizer_values);
  if (args_info->initialStepSize_given)
    write_into_file(outfile, "initialStepSize", args_info->initialStepSize_orig, 0);
  if (args_info->minStepSize_given)
    write_into_file(outfile, "minStepSize", args_info->minStepSize_orig, 0);
  if (args_info->minImprovement_given)
    write_into_file(outfile, "minImprovement", args_info->minImprovement_orig, 0);
  if (args_info->minimizerTolerance_given)
    write_into_file(outfile, "minimizerTolerance", args_info->minimizerTolerance_orig, 0);
  if (args_info->pfScale_given)
    write_into_file(outfile, "pfScale", args_info->pfScale_orig, 0);
  if (args_info->temp_given)
    write_into_file(outfile, "temp", args_info->temp_orig, 0);
  if (args_info->noTetra_given)
    write_into_file(outfile, "noTetra", 0, 0 );
  if (args_info->dangles_given)
    write_into_file(outfile, "dangles", args_info->dangles_orig, 0);
  if (args_info->noLP_given)
    write_into_file(outfile, "noLP", 0, 0 );
  if (args_info->noGU_given)
    write_into_file(outfile, "noGU", 0, 0 );
  if (args_info->noClosingGU_given)
    write_into_file(outfile, "noClosingGU", 0, 0 );
  if (args_info->paramFile_given)
    write_into_file(outfile, "paramFile", args_info->paramFile_orig, 0);
  if (args_info->nsp_given)
    write_into_file(outfile, "nsp", args_info->nsp_orig, 0);
  if (args_info->energyModel_given)
    write_into_file(outfile, "energyModel", args_info->energyModel_orig, 0);
  if (args_info->maxBPspan_given)
    write_into_file(outfile, "maxBPspan", args_info->maxBPspan_orig, 0);
  

  i = EXIT_SUCCESS;
  return i;
}

int
RNApvmin_cmdline_parser_file_save(const char *filename, struct RNApvmin_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", RNAPVMIN_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  i = RNApvmin_cmdline_parser_dump(outfile, args_info);
  fclose (outfile);

  return i;
}

void
RNApvmin_cmdline_parser_free (struct RNApvmin_args_info *args_info)
{
  RNApvmin_cmdline_parser_release (args_info);
}

/** @brief replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = 0;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
RNApvmin_cmdline_parser (int argc, char **argv, struct RNApvmin_args_info *args_info)
{
  return RNApvmin_cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
RNApvmin_cmdline_parser_ext (int argc, char **argv, struct RNApvmin_args_info *args_info,
                   struct RNApvmin_cmdline_parser_params *params)
{
  int result;
  result = RNApvmin_cmdline_parser_internal (argc, argv, args_info, params, 0);

  if (result == EXIT_FAILURE)
    {
      RNApvmin_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
RNApvmin_cmdline_parser2 (int argc, char **argv, struct RNApvmin_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  struct RNApvmin_cmdline_parser_params params;
  
  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;
  params.print_errors = 1;

  result = RNApvmin_cmdline_parser_internal (argc, argv, args_info, &params, 0);

  if (result == EXIT_FAILURE)
    {
      RNApvmin_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
RNApvmin_cmdline_parser_required (struct RNApvmin_args_info *args_info, const char *prog_name)
{
  FIX_UNUSED (args_info);
  FIX_UNUSED (prog_name);
  return EXIT_SUCCESS;
}

/*
 * Extracted from the glibc source tree, version 2.3.6
 *
 * Licensed under the GPL as per the whole glibc source tree.
 *
 * This file was modified so that getopt_long can be called
 * many times without risking previous memory to be spoiled.
 *
 * Modified by Andre Noll and Lorenzo Bettini for use in
 * GNU gengetopt generated files.
 *
 */

/* 
 * we must include anything we need since this file is not thought to be
 * inserted in a file already using getopt.h
 *
 * Lorenzo
 */

struct option
{
  const char *name;
  /* has_arg can't be an enum because some compilers complain about
     type mismatches in all the code that assumes it is an int.  */
  int has_arg;
  int *flag;
  int val;
};

/* This version of `getopt' appears to the caller like standard Unix `getopt'
   but it behaves differently for the user, since it allows the user
   to intersperse the options with the other arguments.

   As `getopt' works, it permutes the elements of ARGV so that,
   when it is done, all the options precede everything else.  Thus
   all application programs are extended to handle flexible argument order.
*/
/*
   If the field `flag' is not NULL, it points to a variable that is set
   to the value given in the field `val' when the option is found, but
   left unchanged if the option is not found.

   To have a long-named option do something other than set an `int' to
   a compiled-in constant, such as set a value from `custom_optarg', set the
   option's `flag' field to zero and its `val' field to a nonzero
   value (the equivalent single-letter option character, if there is
   one).  For long options that have a zero `flag' field, `getopt'
   returns the contents of the `val' field.  */

/* Names for the values of the `has_arg' field of `struct option'.  */
#ifndef no_argument
#define no_argument		0
#endif

#ifndef required_argument
#define required_argument	1
#endif

#ifndef optional_argument
#define optional_argument	2
#endif

struct custom_getopt_data {
	/*
	 * These have exactly the same meaning as the corresponding global variables,
	 * except that they are used for the reentrant versions of getopt.
	 */
	int custom_optind;
	int custom_opterr;
	int custom_optopt;
	char *custom_optarg;

	/* True if the internal members have been initialized.  */
	int initialized;

	/*
	 * The next char to be scanned in the option-element in which the last option
	 * character we returned was found.  This allows us to pick up the scan where
	 * we left off.  If this is zero, or a null string, it means resume the scan by
	 * advancing to the next ARGV-element.
	 */
	char *nextchar;

	/*
	 * Describe the part of ARGV that contains non-options that have been skipped.
	 * `first_nonopt' is the index in ARGV of the first of them; `last_nonopt' is
	 * the index after the last of them.
	 */
	int first_nonopt;
	int last_nonopt;
};

/*
 * the variables optarg, optind, opterr and optopt are renamed with
 * the custom_ prefix so that they don't interfere with getopt ones.
 *
 * Moreover they're static so they are visible only from within the
 * file where this very file will be included.
 */

/*
 * For communication from `custom_getopt' to the caller.  When `custom_getopt' finds an
 * option that takes an argument, the argument value is returned here.
 */
static char *custom_optarg;

/*
 * Index in ARGV of the next element to be scanned.  This is used for
 * communication to and from the caller and for communication between
 * successive calls to `custom_getopt'.
 *
 * On entry to `custom_getopt', 1 means this is the first call; initialize.
 *
 * When `custom_getopt' returns -1, this is the index of the first of the non-option
 * elements that the caller should itself scan.
 *
 * Otherwise, `custom_optind' communicates from one call to the next how much of ARGV
 * has been scanned so far.
 *
 * 1003.2 says this must be 1 before any call.
 */
static int custom_optind = 1;

/*
 * Callers store zero here to inhibit the error message for unrecognized
 * options.
 */
static int custom_opterr = 1;

/*
 * Set to an option character which was unrecognized.  This must be initialized
 * on some systems to avoid linking in the system's own getopt implementation.
 */
static int custom_optopt = '?';

/*
 * Exchange two adjacent subsequences of ARGV.  One subsequence is elements
 * [first_nonopt,last_nonopt) which contains all the non-options that have been
 * skipped so far.  The other is elements [last_nonopt,custom_optind), which contains
 * all the options processed since those non-options were skipped.
 * `first_nonopt' and `last_nonopt' are relocated so that they describe the new
 * indices of the non-options in ARGV after they are moved.
 */
static void exchange(char **argv, struct custom_getopt_data *d)
{
	int bottom = d->first_nonopt;
	int middle = d->last_nonopt;
	int top = d->custom_optind;
	char *tem;

	/*
	 * Exchange the shorter segment with the far end of the longer segment.
	 * That puts the shorter segment into the right place.  It leaves the
	 * longer segment in the right place overall, but it consists of two
	 * parts that need to be swapped next.
	 */
	while (top > middle && middle > bottom) {
		if (top - middle > middle - bottom) {
			/* Bottom segment is the short one.  */
			int len = middle - bottom;
			int i;

			/* Swap it with the top part of the top segment.  */
			for (i = 0; i < len; i++) {
				tem = argv[bottom + i];
				argv[bottom + i] =
					argv[top - (middle - bottom) + i];
				argv[top - (middle - bottom) + i] = tem;
			}
			/* Exclude the moved bottom segment from further swapping.  */
			top -= len;
		} else {
			/* Top segment is the short one.  */
			int len = top - middle;
			int i;

			/* Swap it with the bottom part of the bottom segment.  */
			for (i = 0; i < len; i++) {
				tem = argv[bottom + i];
				argv[bottom + i] = argv[middle + i];
				argv[middle + i] = tem;
			}
			/* Exclude the moved top segment from further swapping.  */
			bottom += len;
		}
	}
	/* Update records for the slots the non-options now occupy.  */
	d->first_nonopt += (d->custom_optind - d->last_nonopt);
	d->last_nonopt = d->custom_optind;
}

/* Initialize the internal data when the first call is made.  */
static void custom_getopt_initialize(struct custom_getopt_data *d)
{
	/*
	 * Start processing options with ARGV-element 1 (since ARGV-element 0
	 * is the program name); the sequence of previously skipped non-option
	 * ARGV-elements is empty.
	 */
	d->first_nonopt = d->last_nonopt = d->custom_optind;
	d->nextchar = NULL;
	d->initialized = 1;
}

#define NONOPTION_P (argv[d->custom_optind][0] != '-' || argv[d->custom_optind][1] == '\0')

/* return: zero: continue, nonzero: return given value to user */
static int shuffle_argv(int argc, char *const *argv,const struct option *longopts,
	struct custom_getopt_data *d)
{
	/*
	 * Give FIRST_NONOPT & LAST_NONOPT rational values if CUSTOM_OPTIND has been
	 * moved back by the user (who may also have changed the arguments).
	 */
	if (d->last_nonopt > d->custom_optind)
		d->last_nonopt = d->custom_optind;
	if (d->first_nonopt > d->custom_optind)
		d->first_nonopt = d->custom_optind;
	/*
	 * If we have just processed some options following some
	 * non-options, exchange them so that the options come first.
	 */
	if (d->first_nonopt != d->last_nonopt &&
			d->last_nonopt != d->custom_optind)
		exchange((char **) argv, d);
	else if (d->last_nonopt != d->custom_optind)
		d->first_nonopt = d->custom_optind;
	/*
	 * Skip any additional non-options and extend the range of
	 * non-options previously skipped.
	 */
	while (d->custom_optind < argc && NONOPTION_P)
		d->custom_optind++;
	d->last_nonopt = d->custom_optind;
	/*
	 * The special ARGV-element `--' means premature end of options.  Skip
	 * it like a null option, then exchange with previous non-options as if
	 * it were an option, then skip everything else like a non-option.
	 */
	if (d->custom_optind != argc && !strcmp(argv[d->custom_optind], "--")) {
		d->custom_optind++;
		if (d->first_nonopt != d->last_nonopt
				&& d->last_nonopt != d->custom_optind)
			exchange((char **) argv, d);
		else if (d->first_nonopt == d->last_nonopt)
			d->first_nonopt = d->custom_optind;
		d->last_nonopt = argc;
		d->custom_optind = argc;
	}
	/*
	 * If we have done all the ARGV-elements, stop the scan and back over
	 * any non-options that we skipped and permuted.
	 */
	if (d->custom_optind == argc) {
		/*
		 * Set the next-arg-index to point at the non-options that we
		 * previously skipped, so the caller will digest them.
		 */
		if (d->first_nonopt != d->last_nonopt)
			d->custom_optind = d->first_nonopt;
		return -1;
	}
	/*
	 * If we have come to a non-option and did not permute it, either stop
	 * the scan or describe it to the caller and pass it by.
	 */
	if (NONOPTION_P) {
		d->custom_optarg = argv[d->custom_optind++];
		return 1;
	}
	/*
	 * We have found another option-ARGV-element. Skip the initial
	 * punctuation.
	 */
	d->nextchar = (argv[d->custom_optind] + 1 + (longopts != NULL && argv[d->custom_optind][1] == '-'));
	return 0;
}

/*
 * Check whether the ARGV-element is a long option.
 *
 * If there's a long option "fubar" and the ARGV-element is "-fu", consider
 * that an abbreviation of the long option, just like "--fu", and not "-f" with
 * arg "u".
 *
 * This distinction seems to be the most useful approach.
 *
 */
static int check_long_opt(int argc, char *const *argv, const char *optstring,
		const struct option *longopts, int *longind,
		int print_errors, struct custom_getopt_data *d)
{
	char *nameend;
	const struct option *p;
	const struct option *pfound = NULL;
	int exact = 0;
	int ambig = 0;
	int indfound = -1;
	int option_index;

	for (nameend = d->nextchar; *nameend && *nameend != '='; nameend++)
		/* Do nothing.  */ ;

	/* Test all long options for either exact match or abbreviated matches */
	for (p = longopts, option_index = 0; p->name; p++, option_index++)
		if (!strncmp(p->name, d->nextchar, nameend - d->nextchar)) {
			if ((unsigned int) (nameend - d->nextchar)
					== (unsigned int) strlen(p->name)) {
				/* Exact match found.  */
				pfound = p;
				indfound = option_index;
				exact = 1;
				break;
			} else if (pfound == NULL) {
				/* First nonexact match found.  */
				pfound = p;
				indfound = option_index;
			} else if (pfound->has_arg != p->has_arg
					|| pfound->flag != p->flag
					|| pfound->val != p->val)
				/* Second or later nonexact match found.  */
				ambig = 1;
		}
	if (ambig && !exact) {
		if (print_errors) {
			fprintf(stderr,
				"%s: option `%s' is ambiguous\n",
				argv[0], argv[d->custom_optind]);
		}
		d->nextchar += strlen(d->nextchar);
		d->custom_optind++;
		d->custom_optopt = 0;
		return '?';
	}
	if (pfound) {
		option_index = indfound;
		d->custom_optind++;
		if (*nameend) {
			if (pfound->has_arg != no_argument)
				d->custom_optarg = nameend + 1;
			else {
				if (print_errors) {
					if (argv[d->custom_optind - 1][1] == '-') {
						/* --option */
						fprintf(stderr, "%s: option `--%s' doesn't allow an argument\n",
							argv[0], pfound->name);
					} else {
						/* +option or -option */
						fprintf(stderr, "%s: option `%c%s' doesn't allow an argument\n",
							argv[0], argv[d->custom_optind - 1][0], pfound->name);
					}

				}
				d->nextchar += strlen(d->nextchar);
				d->custom_optopt = pfound->val;
				return '?';
			}
		} else if (pfound->has_arg == required_argument) {
			if (d->custom_optind < argc)
				d->custom_optarg = argv[d->custom_optind++];
			else {
				if (print_errors) {
					fprintf(stderr,
						"%s: option `%s' requires an argument\n",
						argv[0],
						argv[d->custom_optind - 1]);
				}
				d->nextchar += strlen(d->nextchar);
				d->custom_optopt = pfound->val;
				return optstring[0] == ':' ? ':' : '?';
			}
		}
		d->nextchar += strlen(d->nextchar);
		if (longind != NULL)
			*longind = option_index;
		if (pfound->flag) {
			*(pfound->flag) = pfound->val;
			return 0;
		}
		return pfound->val;
	}
	/*
	 * Can't find it as a long option.  If this is not getopt_long_only, or
	 * the option starts with '--' or is not a valid short option, then
	 * it's an error.  Otherwise interpret it as a short option.
	 */
	if (print_errors) {
		if (argv[d->custom_optind][1] == '-') {
			/* --option */
			fprintf(stderr,
				"%s: unrecognized option `--%s'\n",
				argv[0], d->nextchar);
		} else {
			/* +option or -option */
			fprintf(stderr,
				"%s: unrecognized option `%c%s'\n",
				argv[0], argv[d->custom_optind][0],
				d->nextchar);
		}
	}
	d->nextchar = (char *) "";
	d->custom_optind++;
	d->custom_optopt = 0;
	return '?';
}

static int check_short_opt(int argc, char *const *argv, const char *optstring,
		int print_errors, struct custom_getopt_data *d)
{
	char c = *d->nextchar++;
	const char *temp = strchr(optstring, c);

	/* Increment `custom_optind' when we start to process its last character.  */
	if (*d->nextchar == '\0')
		++d->custom_optind;
	if (!temp || c == ':') {
		if (print_errors)
			fprintf(stderr, "%s: invalid option -- %c\n", argv[0], c);

		d->custom_optopt = c;
		return '?';
	}
	if (temp[1] == ':') {
		if (temp[2] == ':') {
			/* This is an option that accepts an argument optionally.  */
			if (*d->nextchar != '\0') {
				d->custom_optarg = d->nextchar;
				d->custom_optind++;
			} else
				d->custom_optarg = NULL;
			d->nextchar = NULL;
		} else {
			/* This is an option that requires an argument.  */
			if (*d->nextchar != '\0') {
				d->custom_optarg = d->nextchar;
				/*
				 * If we end this ARGV-element by taking the
				 * rest as an arg, we must advance to the next
				 * element now.
				 */
				d->custom_optind++;
			} else if (d->custom_optind == argc) {
				if (print_errors) {
					fprintf(stderr,
						"%s: option requires an argument -- %c\n",
						argv[0], c);
				}
				d->custom_optopt = c;
				if (optstring[0] == ':')
					c = ':';
				else
					c = '?';
			} else
				/*
				 * We already incremented `custom_optind' once;
				 * increment it again when taking next ARGV-elt
				 * as argument.
				 */
				d->custom_optarg = argv[d->custom_optind++];
			d->nextchar = NULL;
		}
	}
	return c;
}

/*
 * Scan elements of ARGV for option characters given in OPTSTRING.
 *
 * If an element of ARGV starts with '-', and is not exactly "-" or "--",
 * then it is an option element.  The characters of this element
 * (aside from the initial '-') are option characters.  If `getopt'
 * is called repeatedly, it returns successively each of the option characters
 * from each of the option elements.
 *
 * If `getopt' finds another option character, it returns that character,
 * updating `custom_optind' and `nextchar' so that the next call to `getopt' can
 * resume the scan with the following option character or ARGV-element.
 *
 * If there are no more option characters, `getopt' returns -1.
 * Then `custom_optind' is the index in ARGV of the first ARGV-element
 * that is not an option.  (The ARGV-elements have been permuted
 * so that those that are not options now come last.)
 *
 * OPTSTRING is a string containing the legitimate option characters.
 * If an option character is seen that is not listed in OPTSTRING,
 * return '?' after printing an error message.  If you set `custom_opterr' to
 * zero, the error message is suppressed but we still return '?'.
 *
 * If a char in OPTSTRING is followed by a colon, that means it wants an arg,
 * so the following text in the same ARGV-element, or the text of the following
 * ARGV-element, is returned in `custom_optarg'.  Two colons mean an option that
 * wants an optional arg; if there is text in the current ARGV-element,
 * it is returned in `custom_optarg', otherwise `custom_optarg' is set to zero.
 *
 * If OPTSTRING starts with `-' or `+', it requests different methods of
 * handling the non-option ARGV-elements.
 * See the comments about RETURN_IN_ORDER and REQUIRE_ORDER, above.
 *
 * Long-named options begin with `--' instead of `-'.
 * Their names may be abbreviated as long as the abbreviation is unique
 * or is an exact match for some defined option.  If they have an
 * argument, it follows the option name in the same ARGV-element, separated
 * from the option name by a `=', or else the in next ARGV-element.
 * When `getopt' finds a long-named option, it returns 0 if that option's
 * `flag' field is nonzero, the value of the option's `val' field
 * if the `flag' field is zero.
 *
 * The elements of ARGV aren't really const, because we permute them.
 * But we pretend they're const in the prototype to be compatible
 * with other systems.
 *
 * LONGOPTS is a vector of `struct option' terminated by an
 * element containing a name which is zero.
 *
 * LONGIND returns the index in LONGOPT of the long-named option found.
 * It is only valid when a long-named option has been found by the most
 * recent call.
 *
 * Return the option character from OPTS just read.  Return -1 when there are
 * no more options.  For unrecognized options, or options missing arguments,
 * `custom_optopt' is set to the option letter, and '?' is returned.
 *
 * The OPTS string is a list of characters which are recognized option letters,
 * optionally followed by colons, specifying that that letter takes an
 * argument, to be placed in `custom_optarg'.
 *
 * If a letter in OPTS is followed by two colons, its argument is optional.
 * This behavior is specific to the GNU `getopt'.
 *
 * The argument `--' causes premature termination of argument scanning,
 * explicitly telling `getopt' that there are no more options.  If OPTS begins
 * with `--', then non-option arguments are treated as arguments to the option
 * '\0'.  This behavior is specific to the GNU `getopt'.
 */

static int getopt_internal_r(int argc, char *const *argv, const char *optstring,
		const struct option *longopts, int *longind,
		struct custom_getopt_data *d)
{
	int ret, print_errors = d->custom_opterr;

	if (optstring[0] == ':')
		print_errors = 0;
	if (argc < 1)
		return -1;
	d->custom_optarg = NULL;

	/* 
	 * This is a big difference with GNU getopt, since optind == 0
	 * means initialization while here 1 means first call.
	 */
	if (d->custom_optind == 0 || !d->initialized) {
		if (d->custom_optind == 0)
			d->custom_optind = 1;	/* Don't scan ARGV[0], the program name.  */
		custom_getopt_initialize(d);
	}
	if (d->nextchar == NULL || *d->nextchar == '\0') {
		ret = shuffle_argv(argc, argv, longopts, d);
		if (ret)
			return ret;
	}
	if (longopts && (argv[d->custom_optind][1] == '-' ))
		return check_long_opt(argc, argv, optstring, longopts,
			longind, print_errors, d);
	return check_short_opt(argc, argv, optstring, print_errors, d);
}

static int custom_getopt_internal(int argc, char *const *argv, const char *optstring,
	const struct option *longopts, int *longind)
{
	int result;
	/* Keep a global copy of all internal members of d */
	static struct custom_getopt_data d;

	d.custom_optind = custom_optind;
	d.custom_opterr = custom_opterr;
	result = getopt_internal_r(argc, argv, optstring, longopts,
		longind, &d);
	custom_optind = d.custom_optind;
	custom_optarg = d.custom_optarg;
	custom_optopt = d.custom_optopt;
	return result;
}

static int custom_getopt_long (int argc, char *const *argv, const char *options,
	const struct option *long_options, int *opt_index)
{
	return custom_getopt_internal(argc, argv, options, long_options,
		opt_index);
}


static char *package_name = 0;

/**
 * @brief updates an option
 * @param field the generic pointer to the field to update
 * @param orig_field the pointer to the orig field
 * @param field_given the pointer to the number of occurrence of this option
 * @param prev_given the pointer to the number of occurrence already seen
 * @param value the argument for this option (if null no arg was specified)
 * @param possible_values the possible values for this option (if specified)
 * @param default_value the default value (in case the option only accepts fixed values)
 * @param arg_type the type of this option
 * @param check_ambiguity @see RNApvmin_cmdline_parser_params.check_ambiguity
 * @param override @see RNApvmin_cmdline_parser_params.override
 * @param no_free whether to free a possible previous value
 * @param multiple_option whether this is a multiple option
 * @param long_opt the corresponding long option
 * @param short_opt the corresponding short option (or '-' if none)
 * @param additional_error possible further error specification
 */
static
int update_arg(void *field, char **orig_field,
               unsigned int *field_given, unsigned int *prev_given, 
               char *value, const char *possible_values[],
               const char *default_value,
               RNApvmin_cmdline_parser_arg_type arg_type,
               int check_ambiguity, int override,
               int no_free, int multiple_option,
               const char *long_opt, char short_opt,
               const char *additional_error)
{
  char *stop_char = 0;
  const char *val = value;
  int found;
  char **string_field;
  FIX_UNUSED (field);

  stop_char = 0;
  found = 0;

  if (!multiple_option && prev_given && (*prev_given || (check_ambiguity && *field_given)))
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: `--%s' (`-%c') option given more than once%s\n", 
               package_name, long_opt, short_opt,
               (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: `--%s' option given more than once%s\n", 
               package_name, long_opt,
               (additional_error ? additional_error : ""));
      return 1; /* failure */
    }

  if (possible_values && (found = check_possible_values((value ? value : default_value), possible_values)) < 0)
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: %s argument, \"%s\", for option `--%s' (`-%c')%s\n", 
          package_name, (found == -2) ? "ambiguous" : "invalid", value, long_opt, short_opt,
          (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: %s argument, \"%s\", for option `--%s'%s\n", 
          package_name, (found == -2) ? "ambiguous" : "invalid", value, long_opt,
          (additional_error ? additional_error : ""));
      return 1; /* failure */
    }
    
  if (field_given && *field_given && ! override)
    return 0;
  if (prev_given)
    (*prev_given)++;
  if (field_given)
    (*field_given)++;
  if (possible_values)
    val = possible_values[found];

  switch(arg_type) {
  case ARG_FLAG:
    *((int *)field) = !*((int *)field);
    break;
  case ARG_INT:
    if (val) *((int *)field) = strtol (val, &stop_char, 0);
    break;
  case ARG_DOUBLE:
    if (val) *((double *)field) = strtod (val, &stop_char);
    break;
  case ARG_ENUM:
    if (val) *((int *)field) = found;
    break;
  case ARG_STRING:
    if (val) {
      string_field = (char **)field;
      if (!no_free && *string_field)
        free (*string_field); /* free previous string */
      *string_field = gengetopt_strdup (val);
    }
    break;
  default:
    break;
  };

  /* check numeric conversion */
  switch(arg_type) {
  case ARG_INT:
  case ARG_DOUBLE:
    if (val && !(stop_char && *stop_char == '\0')) {
      fprintf(stderr, "%s: invalid numeric value: %s\n", package_name, val);
      return 1; /* failure */
    }
    break;
  default:
    ;
  };

  /* store the original value */
  switch(arg_type) {
  case ARG_NO:
  case ARG_FLAG:
    break;
  default:
    if (value && orig_field) {
      if (no_free) {
        *orig_field = value;
      } else {
        if (*orig_field)
          free (*orig_field); /* free previous string */
        *orig_field = gengetopt_strdup (value);
      }
    }
  };

  return 0; /* OK */
}


int
RNApvmin_cmdline_parser_internal (
  int argc, char **argv, struct RNApvmin_args_info *args_info,
                        struct RNApvmin_cmdline_parser_params *params, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error_occurred = 0;
  struct RNApvmin_args_info local_args_info;
  
  int override;
  int initialize;
  int check_required;
  int check_ambiguity;

  char *optarg;
  int optind;
  int opterr;
  int optopt;
  
  package_name = argv[0];
  
  /* TODO: Why is this here? It is not used anywhere. */
  override = params->override;
  FIX_UNUSED(override);

  initialize = params->initialize;
  check_required = params->check_required;

  /* TODO: Why is this here? It is not used anywhere. */
  check_ambiguity = params->check_ambiguity;
  FIX_UNUSED(check_ambiguity);

  if (initialize)
    RNApvmin_cmdline_parser_init (args_info);

  RNApvmin_cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = params->print_errors;
  optopt = '?';

  while (1)
    {
      int option_index = 0;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "detailed-help",	0, NULL, 0 },
        { "full-help",	0, NULL, 0 },
        { "version",	0, NULL, 'V' },
        { "numThreads",	1, NULL, 'j' },
        { "shapeConversion",	1, NULL, 0 },
        { "tauSigmaRatio",	1, NULL, 0 },
        { "objectiveFunction",	1, NULL, 0 },
        { "sampleSize",	1, NULL, 0 },
        { "nonRedundant",	0, NULL, 'N' },
        { "intermediatePath",	1, NULL, 0 },
        { "initialVector",	1, NULL, 0 },
        { "minimizer",	1, NULL, 0 },
        { "initialStepSize",	1, NULL, 0 },
        { "minStepSize",	1, NULL, 0 },
        { "minImprovement",	1, NULL, 0 },
        { "minimizerTolerance",	1, NULL, 0 },
        { "pfScale",	1, NULL, 'S' },
        { "temp",	1, NULL, 'T' },
        { "noTetra",	0, NULL, '4' },
        { "dangles",	1, NULL, 'd' },
        { "noLP",	0, NULL, 0 },
        { "noGU",	0, NULL, 0 },
        { "noClosingGU",	0, NULL, 0 },
        { "paramFile",	1, NULL, 'P' },
        { "nsp",	1, NULL, 0 },
        { "energyModel",	1, NULL, 'e' },
        { "maxBPspan",	1, NULL, 0 },
        { 0,  0, 0, 0 }
      };

      custom_optarg = optarg;
      custom_optind = optind;
      custom_opterr = opterr;
      custom_optopt = optopt;

      c = custom_getopt_long (argc, argv, "hVj:NS:T:4d:P:e:", long_options, &option_index);

      optarg = custom_optarg;
      optind = custom_optind;
      opterr = custom_opterr;
      optopt = custom_optopt;

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          RNApvmin_cmdline_parser_print_help ();
          RNApvmin_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          RNApvmin_cmdline_parser_print_version ();
          RNApvmin_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'j':	/* Set the number of threads used for calculations..  */
        
        
          if (update_arg( (void *)&(args_info->numThreads_arg), 
               &(args_info->numThreads_orig), &(args_info->numThreads_given),
              &(local_args_info.numThreads_given), optarg, 0, 0, ARG_INT,
              check_ambiguity, override, 0, 0,
              "numThreads", 'j',
              additional_error))
            goto failure;
        
          break;
        case 'N':	/* Enable non-redundant sampling strategy..  */
        
        
          if (update_arg((void *)&(args_info->nonRedundant_flag), 0, &(args_info->nonRedundant_given),
              &(local_args_info.nonRedundant_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "nonRedundant", 'N',
              additional_error))
            goto failure;
        
          break;
        case 'S':	/* Set scaling factor for Boltzmann factors to prevent under/overflows..  */
        
        
          if (update_arg( (void *)&(args_info->pfScale_arg), 
               &(args_info->pfScale_orig), &(args_info->pfScale_given),
              &(local_args_info.pfScale_given), optarg, 0, 0, ARG_DOUBLE,
              check_ambiguity, override, 0, 0,
              "pfScale", 'S',
              additional_error))
            goto failure;
        
          break;
        case 'T':	/* Rescale energy parameters to a temperature in degrees centigrade..  */
        
        
          if (update_arg( (void *)&(args_info->temp_arg), 
               &(args_info->temp_orig), &(args_info->temp_given),
              &(local_args_info.temp_given), optarg, 0, "37.0", ARG_DOUBLE,
              check_ambiguity, override, 0, 0,
              "temp", 'T',
              additional_error))
            goto failure;
        
          break;
        case '4':	/* Do not include special tabulated stabilizing energies for tri-, tetra- and hexaloop hairpins..  */
        
        
          if (update_arg((void *)&(args_info->noTetra_flag), 0, &(args_info->noTetra_given),
              &(local_args_info.noTetra_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "noTetra", '4',
              additional_error))
            goto failure;
        
          break;
        case 'd':	/* Specify \"dangling end\" model for bases adjacent to helices in free ends and multi-loops..  */
        
        
          if (update_arg( (void *)&(args_info->dangles_arg), 
               &(args_info->dangles_orig), &(args_info->dangles_given),
              &(local_args_info.dangles_given), optarg, 0, "2", ARG_INT,
              check_ambiguity, override, 0, 0,
              "dangles", 'd',
              additional_error))
            goto failure;
        
          break;
        case 'P':	/* Read energy parameters from paramfile, instead of using the default parameter set..  */
        
        
          if (update_arg( (void *)&(args_info->paramFile_arg), 
               &(args_info->paramFile_orig), &(args_info->paramFile_given),
              &(local_args_info.paramFile_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "paramFile", 'P',
              additional_error))
            goto failure;
        
          break;
        case 'e':	/* Set energy model..  */
        
        
          if (update_arg( (void *)&(args_info->energyModel_arg), 
               &(args_info->energyModel_orig), &(args_info->energyModel_given),
              &(local_args_info.energyModel_given), optarg, 0, 0, ARG_INT,
              check_ambiguity, override, 0, 0,
              "energyModel", 'e',
              additional_error))
            goto failure;
        
          break;

        case 0:	/* Long option with no short option */
          if (strcmp (long_options[option_index].name, "detailed-help") == 0) {
            RNApvmin_cmdline_parser_print_detailed_help ();
            RNApvmin_cmdline_parser_free (&local_args_info);
            exit (EXIT_SUCCESS);
          }

          if (strcmp (long_options[option_index].name, "full-help") == 0) {
            RNApvmin_cmdline_parser_print_full_help ();
            RNApvmin_cmdline_parser_free (&local_args_info);
            exit (EXIT_SUCCESS);
          }

          /* Specify the method used to convert SHAPE reactivities to pairing probabilities..  */
          if (strcmp (long_options[option_index].name, "shapeConversion") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->shapeConversion_arg), 
                 &(args_info->shapeConversion_orig), &(args_info->shapeConversion_given),
                &(local_args_info.shapeConversion_given), optarg, 0, "O", ARG_STRING,
                check_ambiguity, override, 0, 0,
                "shapeConversion", '-',
                additional_error))
              goto failure;
          
          }
          /* Ratio of the weighting factors tau and sigma..  */
          else if (strcmp (long_options[option_index].name, "tauSigmaRatio") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->tauSigmaRatio_arg), 
                 &(args_info->tauSigmaRatio_orig), &(args_info->tauSigmaRatio_given),
                &(local_args_info.tauSigmaRatio_given), optarg, 0, "1.0", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "tauSigmaRatio", '-',
                additional_error))
              goto failure;
          
          }
          /* The energies of the perturbation vector and the discripancies between predicted and observed pairing probabilities contribute to the objective function. This parameter defines, which function is used to process the contributions before summing them up.
          0 square
          1 absolute..  */
          else if (strcmp (long_options[option_index].name, "objectiveFunction") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->objectiveFunction_arg), 
                 &(args_info->objectiveFunction_orig), &(args_info->objectiveFunction_given),
                &(local_args_info.objectiveFunction_given), optarg, 0, "0", ARG_INT,
                check_ambiguity, override, 0, 0,
                "objectiveFunction", '-',
                additional_error))
              goto failure;
          
          }
          /* The iterative minimization process requires to evaluate the gradient of the objective function..  */
          else if (strcmp (long_options[option_index].name, "sampleSize") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->sampleSize_arg), 
                 &(args_info->sampleSize_orig), &(args_info->sampleSize_given),
                &(local_args_info.sampleSize_given), optarg, 0, "1000", ARG_INT,
                check_ambiguity, override, 0, 0,
                "sampleSize", '-',
                additional_error))
              goto failure;
          
          }
          /* Write an output file for each iteration of the minimization process..  */
          else if (strcmp (long_options[option_index].name, "intermediatePath") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->intermediatePath_arg), 
                 &(args_info->intermediatePath_orig), &(args_info->intermediatePath_given),
                &(local_args_info.intermediatePath_given), optarg, 0, 0, ARG_STRING,
                check_ambiguity, override, 0, 0,
                "intermediatePath", '-',
                additional_error))
              goto failure;
          
          }
          /* Specify the vector of initial pertubations..  */
          else if (strcmp (long_options[option_index].name, "initialVector") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->initialVector_arg), 
                 &(args_info->initialVector_orig), &(args_info->initialVector_given),
                &(local_args_info.initialVector_given), optarg, 0, "0", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "initialVector", '-',
                additional_error))
              goto failure;
          
          }
          /* Set the minimizing algorithm used for finding an appropriate perturbation vector..  */
          else if (strcmp (long_options[option_index].name, "minimizer") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->minimizer_arg), 
                 &(args_info->minimizer_orig), &(args_info->minimizer_given),
                &(local_args_info.minimizer_given), optarg, RNApvmin_cmdline_parser_minimizer_values, "default", ARG_ENUM,
                check_ambiguity, override, 0, 0,
                "minimizer", '-',
                additional_error))
              goto failure;
          
          }
          /* The initial stepsize for the minimizer methods..  */
          else if (strcmp (long_options[option_index].name, "initialStepSize") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->initialStepSize_arg), 
                 &(args_info->initialStepSize_orig), &(args_info->initialStepSize_given),
                &(local_args_info.initialStepSize_given), optarg, 0, "0.01", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "initialStepSize", '-',
                additional_error))
              goto failure;
          
          }
          /* The minimal stepsize for the minizimer methods..  */
          else if (strcmp (long_options[option_index].name, "minStepSize") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->minStepSize_arg), 
                 &(args_info->minStepSize_orig), &(args_info->minStepSize_given),
                &(local_args_info.minStepSize_given), optarg, 0, "1e-15", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "minStepSize", '-',
                additional_error))
              goto failure;
          
          }
          /* The minimal improvement in the default minizimer method that has to be surpassed to considered a new result a better one..  */
          else if (strcmp (long_options[option_index].name, "minImprovement") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->minImprovement_arg), 
                 &(args_info->minImprovement_orig), &(args_info->minImprovement_given),
                &(local_args_info.minImprovement_given), optarg, 0, "1e-3", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "minImprovement", '-',
                additional_error))
              goto failure;
          
          }
          /* The tolerance to be used in the GSL minimizer methods..  */
          else if (strcmp (long_options[option_index].name, "minimizerTolerance") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->minimizerTolerance_arg), 
                 &(args_info->minimizerTolerance_orig), &(args_info->minimizerTolerance_given),
                &(local_args_info.minimizerTolerance_given), optarg, 0, "1e-3", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "minimizerTolerance", '-',
                additional_error))
              goto failure;
          
          }
          /* Produce structures without lonely pairs (helices of length 1)..  */
          else if (strcmp (long_options[option_index].name, "noLP") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->noLP_flag), 0, &(args_info->noLP_given),
                &(local_args_info.noLP_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "noLP", '-',
                additional_error))
              goto failure;
          
          }
          /* Do not allow GU pairs..  */
          else if (strcmp (long_options[option_index].name, "noGU") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->noGU_flag), 0, &(args_info->noGU_given),
                &(local_args_info.noGU_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "noGU", '-',
                additional_error))
              goto failure;
          
          }
          /* Do not allow GU pairs at the end of helices..  */
          else if (strcmp (long_options[option_index].name, "noClosingGU") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->noClosingGU_flag), 0, &(args_info->noClosingGU_given),
                &(local_args_info.noClosingGU_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "noClosingGU", '-',
                additional_error))
              goto failure;
          
          }
          /* Allow other pairs in addition to the usual AU,GC,and GU pairs..  */
          else if (strcmp (long_options[option_index].name, "nsp") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->nsp_arg), 
                 &(args_info->nsp_orig), &(args_info->nsp_given),
                &(local_args_info.nsp_given), optarg, 0, 0, ARG_STRING,
                check_ambiguity, override, 0, 0,
                "nsp", '-',
                additional_error))
              goto failure;
          
          }
          /* Set the maximum base pair span..  */
          else if (strcmp (long_options[option_index].name, "maxBPspan") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->maxBPspan_arg), 
                 &(args_info->maxBPspan_orig), &(args_info->maxBPspan_given),
                &(local_args_info.maxBPspan_given), optarg, 0, "-1", ARG_INT,
                check_ambiguity, override, 0, 0,
                "maxBPspan", '-',
                additional_error))
              goto failure;
          
          }
          
          break;
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", RNAPVMIN_CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



	FIX_UNUSED(check_required);

  RNApvmin_cmdline_parser_release (&local_args_info);

  if ( error_occurred )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
      int found_prog_name = 0;
      /* whether program name, i.e., argv[0], is in the remaining args
         (this may happen with some implementations of getopt,
          but surely not with the one included by gengetopt) */


      args_info->inputs_num = argc - optind - found_prog_name;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  
  RNApvmin_cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
/* vim: set ft=c noet ts=8 sts=8 sw=8 tw=80 nojs spell : */
